import cinder_contexts as contexts

from test_utils import (
    CharmTestCase
)

TO_PATCH = [
    'config',
    'service_name',
]


class TestCinderContext(CharmTestCase):

    def setUp(self):
        super(TestCinderContext, self).setUp(contexts, TO_PATCH)
        self.service_name.return_value = "cinder-vmware"
        self.config.side_effect = self.test_config.get

    def test_config_incomplete(self):
        self.assertRaises(contexts.VMwareIncompleteConfiguration,
                          contexts.VMwareSubordinateContext())

    def test_config_complete(self):
        self.test_config.set('host-ip', 'vcenter')
        self.test_config.set('host-username', 'testing')
        self.test_config.set('host-password', 'foobar')
        self.test_config.set('volume-folder', 'newvolumes')
        self.assertEquals(
            contexts.VMwareSubordinateContext()(),
            {"cinder": {
                "/etc/cinder/cinder.conf": {
                    "sections": {
                        'cinder-vmware': [
                            ('vmware_host_ip', 'vcenter'),
                            ('vmware_host_username', 'testing'),
                            ('vmware_host_password', 'foobar'),
                            ('vmware_volume_folder', 'newvolumes'),
                            ('volume_backend_name', 'cinder-vmware'),
                            ('volume_driver',
                             'cinder.volume.drivers.vmware.'
                             'vmdk.VMwareVcVmdkDriver'),
                        ]
                    }
                }
            }})
